<?php
/*
Plugin Name: showmylicence
Plugin Script: showmylicence.php
Plugin URI: http://n2b.org/showmylicence (where should people go for this plugin?)
Description: Gives the user the ability to set licence for each post sepertly
Version: 1.0
License: GPL
Author: Nitzan Brumer
Author URI: http://n2b.org (your blog/site URL)
// following 3 params needed for Installer
// cf http://mattread.com/projects/wp-plugins/installer-the-plugin/
Min WP Version: 1.5
Max WP Version: 2.6
// Update Server: http://.../showmylicence (where should Installer look for update?)
PHP Template by: http://web.forret.com/tools/wp-plugin.asp

=== RELEASE NOTES ===
2008-07-24 - v1.0 - first version

This plugin has two options
1. Licence at the end of each post 
2. Licence that is called throgh a function.

There is an option screen at the admin under options and at the end of each post there is a licence selector

*/
###################
# Initial Settings
###################

register_activation_hook(__FILE__,'sml_install');
showmylicence_add_options();

function showmylicence_add_options() {
	//This function writes options to the DB.
	add_option('showmylicence_eop', '1');  //Does the user want to show licence at the end of each post?
	add_option('sml_default_licence', '0');// What is the default blog licence?
	add_option('sml_show_default_licence', '0');	//always show a licence?

}


add_filter('the_content', 'showmylicence_filter');
add_action('admin_menu', 'sml_add_pages');

#################################### BEGINING OF EDITOR SECTION #############################
#
#  The Following section generate a box in the post / page editor that allow the editor
#  to select what kind of licence he wants for this post.
#
#############################################################################################

add_action('admin_menu', 'sml_add_custom_box');
add_action('save_post', 'sml_save_postdata');

function sml_add_custom_box() {

  if( function_exists( 'add_meta_box' )) {
    add_meta_box( 'sml-box', __( 'Assigning Licence', 'myplugin_textdomain' ), 
                'sml_inner_custom_box', 'post', 'advanced' );
    add_meta_box( 'sml-box', __( 'Assigning Licence', 'myplugin_textdomain' ), 
                'sml_inner_custom_box', 'page', 'advanced' );
   } else {
    add_action('dbx_post_advanced', 'sml_old_custom_box' );
    add_action('dbx_page_advanced', 'sml_old_custom_box' );
  }
}

function sml_inner_custom_box() {

  	echo "<p>";
  	echo '<input type="hidden" name="myplugin_noncename" id="myplugin_noncename" value="' . 
    wp_create_nonce( plugin_basename(__FILE__) ) . '" />';
	echo generateLicenceMenu(checkForLicence($_GET['post']));
  	echo "</p>";
	echo "<p>";
  	echo "You can select a Licence type from this menu. the licence will be assignd only to this post";
    echo "</p>";
}


/* Prints the edit form for pre-WordPress 2.5 post/page */
function sml_old_custom_box() {

  echo '<div class="dbx-b-ox-wrapper">' . "\n";
  echo '<fieldset id="myplugin_fieldsetid" class="dbx-box">' . "\n";
  echo '<div class="dbx-h-andle-wrapper"><h3 class="dbx-handle">' . 
        __( 'My Post Section Title', 'myplugin_textdomain' ) . "</h3></div>";   
   
  echo '<div class="dbx-c-ontent-wrapper"><div class="dbx-content">';

  // output editing form

  sml_inner_custom_box();

  // end wrapper

  echo "</div></div></fieldset></div>\n";
}

/* When the post is saved, saves our custom data */
function sml_save_postdata( $post_id ) {

  // verify this came from the our screen and with proper authorization,
  // because save_post can be triggered at other times

  if ( !wp_verify_nonce( $_POST[myplugin_noncename], plugin_basename(__FILE__) )) {
    return $post_id;
  }

  if ( 'page' == $_POST['post_type'] ) {
    if ( !current_user_can( 'edit_page', $post_id ))
      return $post_id;
  } else {
    if ( !current_user_can( 'edit_post', $post_id ))
      return $post_id;
  }

  // OK, we're authenticated: we need to find and save the data

  	$mydata = $_POST['menu'];
	if ($mydata!=0 || ($mydata==0 && checkForLicence($post_id)))
		addLicenceToPost($post_id,$mydata );

  

   return $mydata;
}

#################################### END OF EDITOR SECTION #############################



function showmylicence_filter($content) {
	global $wpdb;
	// get your parameter values from the database
	$showmylicence_nb_widgets = get_option('showmylicence_nb_widgets');
	$showmylicence_eop =  get_option('showmylicence_eop');

		$showmylicence_html = generateLable();

	if( is_single() && $showmylicence_eop == '1')
		$content = $content . $showmylicence_html;
	else
		$content = $content;
	return $content;
}






function sml_add_pages() {
	 add_options_page('Show My Licence', 'Show My Licence', 8, basename (__FILE__), 'sml_options_page');
}



function sml_options_page() {
	   global $post_msg;
	   $screen=0;
	   if(!$_GET['screen'])
	   		$screen="1";
	   if( $_POST['action'] == 'update' ) {
			if ($_GET['screen']=="add_licence"){
				$name = $_POST['name'];
				$url=$_POST['url'];
				$bigimg=$_POST['image1'];
				$smallimg=$_POST['image2'];
				if($_GET['edit'])
					updateLicence($name,$smallimg, $bigimg, $url, $_GET['edit']);
				else
					addNewLicence($name,$smallimg, $bigimg, $url);
			}
			else if ($_GET['screen']=="options" || $screen==1){
				$first = $_POST['menu'];
				$second =  $_POST['my_default_licence'];
				$third = $_POST['show_at_eop'];
			
				
				update_option('sml_default_licence', $first);
				if ($second==1)
					update_option('sml_show_default_licence', '1');
				else
					update_option('sml_show_default_licence', '0');
				}

				
				if ($third==1)
					update_option('showmylicence_eop', '1');
				else
					update_option('showmylicence_eop', '0');
				}



    ?>    <div class="wrap">
    
    
 	<?php 
 	
 	$url = get_bloginfo ('wpurl').'/wp-admin/options-general.php?page=showmylicence.php';
 	 ?>
 	 <ul id="submenu">
 	 <?php	
 		echo "<li><a href='". $url. "&screen=options" . "'>options</a></li>";
 		echo "<li><a href='". $url. "&screen=add_licence" . "'>add licence</a></li>";
 		echo "<li><a href='". $url. "&screen=about" . "'>about</a> </li>";
 	 	echo "</ul>";
  	
 	if ($_GET['screen']=="about")
 		{
  		 aboutScreen();
 		}
 	else if ($_GET['screen']=="add_licence"){
 		addLicenceScreen();
  	}
    else if($_GET['screen']=="reset"){
    	resetLicences();
    	echo "<h2>Reset</h2>";
    	echo "All Licences were reset to default value";
    }
    else
    	pluginOptionScreen();
 
  //	
 	?>
	</div>
    <?php
}

function aboutScreen(){

$header = "About";
$body1 = "This plugin gives you the ability to set for each page or post its licence.";
$body2 = "use the Add Licence link to add licences to the list";
$body3 = "Use the option link to set this plugin options";
$link = get_bloginfo ('wpurl').'/wp-admin/options-general.php?page=showmylicence.php&screen=reset';
echo "<h2>".$header."</h2>";
echo $body1 . "<br>" . $body2 . "<br>".$body3;

echo "<h2>Reset</h2>";
echo "Too much mess? wanna start over? <a href=\"". $link ."\">click here</a>";


}

function pluginOptionScreen()  {
echo "<h2>Plugin Options</h2>";
 echo "<form name =\"Plugin Options\"method=\"post\" action=\" ${_SERVER[REQUEST_URI]} \">";
    wp_nonce_field('update-options'); 
   ?>
   <table class="form-table"><tbody>
   <tr valign="top">
   <th scope="row">Default Licence</th>
   <td>

  <?php echo generateLicenceMenu(get_option('sml_default_licence'));?>

	This menu gives you the ability to set the blogs Default licence
</td>
</tr>
   <tr valign="top">
   <th scope="row">Display Settings</th>
   <td>
   <ul><li>
    <label for="my_default_licence"><input name="my_default_licence" TYPE=CHECKBOX value="1"
	<?php if (get_option('sml_show_default_licence')==1) 
		echo " checked" ;
	 ?>
/>
	Display default licence if no licence is attached to post
	</label>
	</li><li>
 <label for="show_at_eop"><input name="show_at_eop" TYPE=CHECKBOX value="1"
	<?php if (get_option('showmylicence_eop')==1) 
		echo " checked" ;
	 ?>
/>
	Automaticly display licence at the end of the post
	</label>
</li>
   	</tr></tbody>
	</table>
    <input type="hidden" name="action" value="update" />
    <input type="hidden" name="page_options" value="new_option_name,some_other_option,option_etc" />

   <p class="submit">
	<input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
	</p>
	</form><?php
}

function addLicenceScreen(){
	echo "<h2>Current licences</h2>";
	echo displayLicencesTable();  
	if($_GET['edit'])
		$licence = getLicence($_GET['edit']);
	?><h2>Add A new Licence</h2>
 	<?php 
 	
    echo "<form name =\"add_licence\"method=\"post\" action=\" ${_SERVER[REQUEST_URI]} \">";
    wp_nonce_field('update-options'); 
   ?>
   <table class="form-table"><tbody>
   	<tr><td>Licence Name:</td><td>  <input name="name" type="text" value="<?php echo  $licence['name']; ?>"/></td></tr>
	<tr><td>Licence URL: </td><td> <input name="url" type="text" value="<?php echo  $licence['url']; ?>"/> </td></tr>
	<tr><td>Licence 1st Image:</td><td> <input name="image1" type="text" value="<?php echo $licence['bigimg']; ?>"/></td></tr>
	<tr><td>Licence 2nd Image:</td><td> <input name="image2" type="text" value="<?php echo $licence['smallimg']; ?>"/> </td></tr>
    <input type="hidden" name="action" value="update" />
    <input type="hidden" name="page_options" value="new_option_name,some_other_option,option_etc" />
   	</tbody>
	</table>
   <p class="submit">
	<input type="submit" name="Submit" value="<?php _e('Save Changes') ?>" />
	</p>
	</form>
 		<?php

}



function sayIt(){
	
	echo generateLable();
	
}

function sml_show(){
	
	echo generateLable();
	
}
function displayLicencesTable(){
	global $wpdb;
	$link = get_bloginfo ('wpurl').'/wp-admin/options-general.php?page=showmylicence.php&screen=add_licence';
	$table_name = $wpdb->prefix . "smlicence";
			$sql = "SELECT * FROM ". $table_name ;
			$result = $wpdb->get_results($sql, ARRAY_A);
			$temp = "<table class=\"form-table\"><tbody><tr><td>name</td>" .
					"<td>link</td><td>Big image</td><td>Small Image</td><td>action</td></tr>";
			$temp = $temp ;
						foreach ($result as $licence)
			{
				$editLink = $link . "&edit=" . $licence['id'];
				$temp = $temp. "<tr><td>" .  $licence['name']."</td>" .
						"			<td><a href=\"".$licence['url'] . "\">link</a></td>" .
								"<td><img src=\"".$licence['bigimg']."\"/></td>" .
										"<td><img src=\"".$licence['smallimg']."\"/></td>" .
										"<td><a href=\"". $editLink. "\">edit</a></td></tr>";
										
			}
			$temp = $temp . "</tbody></table>";
			return $temp;
			
}

function getLicence($id){
	global $wpdb;
	$table_name = $wpdb->prefix . "smlicence";
	$sql = "SELECT * FROM ". $table_name . " where id=".$id;
	$result = $wpdb->get_row($sql, ARRAY_A);
	return $result;
	
}

############################################
#	checkForLicence gets a post Id and
#	checks in the DB if the post has
#	a Licence. if so it returns the Licence
############################################

function checkForLicence($id){
		global $wpdb;
		$thePostID = $id;
		//We Go to the DB and grab the post licence
		$table_posts = $wpdb->prefix . "smlpost";
		$sql = "SELECT licenceNumber FROM ". $table_posts .
				" WHERE postnumber = " . $thePostID ;
		
		$result = $wpdb->get_var($sql);
		return $result;	
}


#########################################
#  	This function generates the signature 
#	it returns the licence Image
#########################################


function generateLable(){
		global $wp_query;
		global $wpdb;
		$licence = checkForLicence($wp_query->post->ID);
		if(!$licence && get_option('sml_show_default_licence')==1)
			{
				$licence = get_option('sml_default_licence');
			}
		if($licence)
		{
			$table_name = $wpdb->prefix . "smlicence";
			$sql = "SELECT * FROM ". $table_name .
					" WHERE id = " . $licence ;
			
			$result = $wpdb->get_row($sql, ARRAY_A);
			$link = $result['url'];
			$name = $result['name'];
			$img = $result['bigimg'];
			
			$myLicence = "<a href='".$link."'><img src='". $img  ."'></img></a>";
		}
		else
			$myLicence = "";  //don't show anything
			
		return $myLicence;
}

function generateLicenceMenu($option){
	
			global $wpdb;
			
			$table_name = $wpdb->prefix . "smlicence";
			$sql = "SELECT name,id FROM ". $table_name ;
					
			$result = $wpdb->get_results($sql, ARRAY_A);
			if($option==0)
				$temp = "<select name=\"menu\"><option value=\"0\" selected>(No Licene)</option>";
			else
				$temp = "<select name=\"menu\"><option value=\"0\">(No Licene)</option>";
			foreach ($result as $licence)
			{
				$count= $count+ 1;
				$temp = $temp. "<option value=".$licence['id'];
				if ($licence['id']==$option)
					$temp = $temp. " selected ";
				$temp = $temp. ">".$licence['name']."</option>";
			}
			
			$temp = $temp. "</select>";
			
			return $temp;
}


function addLicenceToPost($postid, $licenceId){
	 global $wpdb;
	 $table_posts = $wpdb->prefix . "smlpost";
	 
	 if (checkForLicence($postid))
	 	{
	 		$sql = "UPDATE " . $table_posts .
            " SET licenceNumber=" . $licenceId . " WHERE  postnumber=" . $postid
            ;
	 	}
	else
		{
			$sql = "INSERT INTO " . $table_posts .
            " (postnumber, licenceNumber  ) " .
            "VALUEDROP TABLES ('". $wpdb->escape($postid) . "','" . $wpdb->escape($licenceId) ."')";
		}
	 $result = $wpdb->query( $sql );
	 
}

function updateLicence($name,$smallimg, $bigimg, $url,$id){
			global $wpdb;
    	 $table_name = $wpdb->prefix . "smlicence";
    	 $insert = "UPDATE " . $table_name .
            " SET name='". $wpdb->escape($name) . "' , smallimg='" . $wpdb->escape($smallimg) . 
			"' , bigimg='" . $wpdb->escape($bigimg). "' , url='" . $wpdb->escape($url).
			"' Where id=". $id;
		//echo $insert;
  		$results = $wpdb->query( $insert );
}

function addNewLicence($name, $url, $bigimg,$smallimg){
			global $wpdb;
    	 $table_name = $wpdb->prefix . "smlicence";
    	 $insert = "INSERT INTO " . $table_name .
            " (name,smallimg ,bigimg, url ) " .
            "VALUES ('". $wpdb->escape($name) . "','" . $wpdb->escape($smallimg) . "','" . $wpdb->escape($bigimg). "','" . $wpdb->escape($url)."')";

  		$results = $wpdb->query( $insert );
}


#######################################
#
# This is the installation function
# Should create the DB and insert data
#
#######################################

function sml_install () {
   global $wpdb;
   $sml_db_version = "1.0";
   $table_name = $wpdb->prefix . "smlicence";
   $table_posts = $wpdb->prefix . "smlpost";
    if($wpdb->get_var("SHOW TABLES LIKE '$table_name'") != $table_name) {
    	$sql = "CREATE TABLE " . $table_name . " (
		  id mediumint(9) NOT NULL AUTO_INCREMENT,
		  name VARCHAR(55) NOT NULL,
		  smallimg VARCHAR(70) NOT NULL,
		  bigimg VARCHAR(70) NOT NULL,
		  url VARCHAR(70) NOT NULL,
		  UNIQUE KEY id (id)
			);";
			
		$sql2 = "CREATE TABLE " . $table_posts . " (
		  id mediumint(9) NOT NULL AUTO_INCREMENT,
		  licenceNumber mediumint(9) NOT NULL,
		  postnumber mediumint(9) NOT NULL,
		  UNIQUE KEY id (id)
			);";

		require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
    	dbDelta($sql2);
    	add_option("sml_db_version", $sml_db_version);
    }
   fillLicenceTabel();
}

############## END OF INSTALL ###############################

function fillLicenceTabel(){
	   //few basic licences
    addNewLicence("CC-by", "http://creativecommons.org/licenses/by/3.0/", "http://i.creativecommons.org/l/by/2.5/88x31.png", "http://i.creativecommons.org/l/by/2.5/80x15.png");
	addNewLicence("CC-by-sa", "http://creativecommons.org/licenses/by-sa/3.0/", "http://i.creativecommons.org/l/by-sa/2.5/88x31.png", "http://i.creativecommons.org/l/by-sa/2.5/80x15.png");
	addNewLicence("CC-by-nd", "http://creativecommons.org/licenses/by-nd/2.5/", "http://i.creativecommons.org/l/by-nd/2.5/88x31.png", "http://i.creativecommons.org/l/by-nd/2.5/80x15.png");
	addNewLicence("CC-by-nc", "http://creativecommons.org/licenses/by-nc/3.0/", "http://i.creativecommons.org/l/by-nc/3.0/88x31.png", "http://i.creativecommons.org/l/by-nc/3.0/80x15.png");
	addNewLicence("CC-by-nc-nd", "http://creativecommons.org/licenses/by-nc-nd/2.5/", "http://i.creativecommons.org/l/by-nc-nd/2.5/88x31.png", "http://i.creativecommons.org/l/by-nc-nd/2.5/80x15.png");
	addNewLicence("CC-by-nc-sa", "http://creativecommons.org/licenses/by-nc-sa/3.0/", "http://i.creativecommons.org/l/by-nc-sa/3.0/88x31.png", "http://i.creativecommons.org/l/by-nc-sa/3.0/80x15.png");
  
}

function resetLicences(){
	global $wpdb;
	update_option('showmylicence_eop', '1');  //Does the user want to show licence at the end of each post?
	update_option('sml_default_licence', '0');// What is the default blog licence?
	update_option('sml_show_default_licence', '0');
	$table_name = $wpdb->prefix . "smlicence";
	$sql = "DROP TABLE ". $table_name;
	$results = $wpdb->query( $sql );
		$sql = "CREATE TABLE " . $table_name . " (
		  id mediumint(9) NOT NULL AUTO_INCREMENT,
		  name VARCHAR(55) NOT NULL,
		  smallimg VARCHAR(70) NOT NULL,
		  bigimg VARCHAR(70) NOT NULL,
		  url VARCHAR(70) NOT NULL,
		  UNIQUE KEY id (id)
			);";
	require_once(ABSPATH . 'wp-admin/includes/upgrade.php');
		dbDelta($sql);
		//$results = $wpdb->query( $sql );
	 fillLicenceTabel();
	 
}
?>
